<a id="index-0"></a>

<a id="api"></a>

# Weblate’s REST API

The API is accessible on the `/api/` URL and it is based on
[Django REST framework](https://www.django-rest-framework.org/).
You can use it directly or by [Weblate Client](https://docs.weblate.org/en/weblate-2026.10/wlc.md#wlc).

The API is also documented using OpenAPI 3.1 on the `/api/schema/` URL, you
can browse at `/api/docs/`.

<a id="api-generic"></a>

## Authentication and generic parameters

The read-only API is available without authentication unless
[`REQUIRE_LOGIN`](https://docs.weblate.org/en/weblate-2026.10/admin/config.md#std-setting-REQUIRE_LOGIN) is turned on. Unauthenticated requests are heavily
throttled (by default to 100 requests per day), so it is recommended to use
authentication.

The authentication uses a token, which you can get in your profile. Use it in
the `Authorization` header with the `Token` or `Bearer` scheme.
Unsupported schemes, such as `Basic`, return [401 Unauthorized](https://developer.mozilla.org/en-US/docs/Web/HTTP/Reference/Status/401), even
for public endpoints or when you are signed in using a browser session.

### ANY /

Generic request behaviour for the API, the headers, status codes and
parameters here apply to all endpoints as well.

* **Query Parameters:**
  * **format** – Response format (overrides [Accept](https://www.rfc-editor.org/rfc/rfc7231#section-5.3.2)).
    Possible values depend on REST framework setup,
    by default `json`, `csv` and `api` are supported. The
    latter provides a web browser interface for the API.
  * **page** – Returns given page of paginated results (use next and previous fields in response to automate the navigation).
  * **page_size** – Return the given number of items per request.
    The default is 50 and the maximum is 1000.
    For the units endpoints the default is 100 with
    a maximum of 10000. The default value is also
    configurable using the PAGE_SIZE setting.
* **Request Headers:**
  * [Accept](https://www.rfc-editor.org/rfc/rfc7231#section-5.3.2) – the response content type depends on
    [Accept](https://www.rfc-editor.org/rfc/rfc7231#section-5.3.2) header
  * [Authorization](https://www.rfc-editor.org/rfc/rfc7235#section-4.2) – optional token to authenticate as
    `Authorization: Token YOUR-TOKEN`
* **Response Headers:**
  * [Content-Type](https://www.rfc-editor.org/rfc/rfc7231#section-3.1.1.5) – this depends on [Accept](https://www.rfc-editor.org/rfc/rfc7231#section-5.3.2)
    header of request
  * [Allow](https://www.rfc-editor.org/rfc/rfc7231#section-7.4.1) – list of allowed HTTP methods on object
* **Response JSON Object:**
  * **detail** (*string*) – verbose description of the result (for HTTP status codes other than [200 OK](https://developer.mozilla.org/en-US/docs/Web/HTTP/Reference/Status/200))
  * **count** (*int*) – total item count for object lists
  * **next** (*string*) – next page URL for object lists
  * **previous** (*string*) – previous page URL for object lists
  * **results** (*array*) – results for object lists
  * **url** (*string*) – URL to access this resource using the API
  * **web_url** (*string*) – URL to access this resource using web browser
* **Status Codes:**
  * [200 OK](https://developer.mozilla.org/en-US/docs/Web/HTTP/Reference/Status/200) – when request was correctly handled
  * [201 Created](https://developer.mozilla.org/en-US/docs/Web/HTTP/Reference/Status/201) – when a new object was created successfully
  * [204 No Content](https://developer.mozilla.org/en-US/docs/Web/HTTP/Reference/Status/204) – when an object was deleted successfully
  * [400 Bad Request](https://developer.mozilla.org/en-US/docs/Web/HTTP/Reference/Status/400) – when form parameters are missing
  * [401 Unauthorized](https://developer.mozilla.org/en-US/docs/Web/HTTP/Reference/Status/401) – when authentication credentials are invalid or the authentication scheme is unsupported
  * [403 Forbidden](https://developer.mozilla.org/en-US/docs/Web/HTTP/Reference/Status/403) – when access is denied
  * [429 Too Many Requests](https://developer.mozilla.org/en-US/docs/Web/HTTP/Reference/Status/429) – when throttling is in place

<a id="api-tokens"></a>

### Authentication tokens

#### Versionchanged
Changed in version 4.10: Project scoped tokens were introduced in the 4.10 release.

Each user has a personal access token which can be obtained in the user
profile. Newly generated user tokens have the `wlu_` prefix.

It is possible to create project scoped tokens for API access to given project
only. These tokens can be identified by the `wlp_` prefix.

#### SEE ALSO
* [Registration and user profile](https://docs.weblate.org/en/weblate-2026.10/user/profile.md)
* [Per-project access tokens](https://docs.weblate.org/en/weblate-2026.10/admin/access.md#project-api)
* [Project access control](https://docs.weblate.org/en/weblate-2026.10/admin/access.md#acl)

### Authentication examples

**Example request:**

```http
GET /api/ HTTP/1.1
Host: example.com
Accept: application/json, text/javascript
Authorization: Token YOUR-TOKEN
```

**Example response:**

```http
HTTP/1.0 200 OK
Date: Fri, 25 Mar 2016 09:46:12 GMT
Server: WSGIServer/0.1 Python/2.7.11+
Vary: Accept, Accept-Language, Cookie
X-Frame-Options: SAMEORIGIN
Content-Type: application/json
Content-Language: en
Allow: GET, HEAD, OPTIONS

{
    "projects":"http://example.com/api/projects/",
    "components":"http://example.com/api/components/",
    "translations":"http://example.com/api/translations/",
    "languages":"http://example.com/api/languages/"
}
```

**CURL example:**

```sh
curl \
    -H "Authorization: Token TOKEN" \
    https://example.com/api/
```

### Passing Parameters Examples

For the [POST](https://www.rfc-editor.org/rfc/rfc7231#section-4.3.3) method the parameters can be specified either as
form submission (*application/x-www-form-urlencoded*) or as JSON
(*application/json*).

**Form request example:**

```http
POST /api/projects/hello/repository/ HTTP/1.1
Host: example.com
Accept: application/json
Content-Type: application/x-www-form-urlencoded
Authorization: Token TOKEN

operation=pull
```

**JSON request example:**

```http
POST /api/projects/hello/repository/ HTTP/1.1
Host: example.com
Accept: application/json
Content-Type: application/json
Authorization: Token TOKEN
Content-Length: 20

{"operation":"pull"}
```

**CURL example:**

```sh
curl \
    -d operation=pull \
    -H "Authorization: Token TOKEN" \
    http://example.com/api/components/hello/weblate/repository/
```

**CURL JSON example:**

```sh
curl \
    --data-binary '{"operation":"pull"}' \
    -H "Content-Type: application/json" \
    -H "Authorization: Token TOKEN" \
    http://example.com/api/components/hello/weblate/repository/
```

<a id="api-category"></a>

### Components and categories

To access a component which is nested inside a [Category](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#category), you need to URL
encode the category name into a component name separated with a slash. For
example `usage` placed in a `docs` category needs to be used as
`docs%252Fusage`. Full URL in this case would be for example
`https://example.com/api/components/hello/docs%252Fusage/repository/`.

<a id="api-rate"></a>

### API rate limiting

The API requests are rate limited; the default configuration limits it to 100
requests per day for anonymous users and 5000 requests per hour for authenticated
users.

Configure the default limits in `settings.py` using
[`API_RATELIMIT_ANON`](https://docs.weblate.org/en/weblate-2026.10/admin/config.md#std-setting-API_RATELIMIT_ANON) and [`API_RATELIMIT_USER`](https://docs.weblate.org/en/weblate-2026.10/admin/config.md#std-setting-API_RATELIMIT_USER).

In the Docker container this can be configured using
[`WEBLATE_API_RATELIMIT_ANON`](https://docs.weblate.org/en/weblate-2026.10/admin/install/docker.md#envvar-WEBLATE_API_RATELIMIT_ANON) and [`WEBLATE_API_RATELIMIT_USER`](https://docs.weblate.org/en/weblate-2026.10/admin/install/docker.md#envvar-WEBLATE_API_RATELIMIT_USER).

Use [`API_RATELIMIT_USER_OVERRIDES`](https://docs.weblate.org/en/weblate-2026.10/admin/config.md#std-setting-API_RATELIMIT_USER_OVERRIDES) to give an automation account a
different limit. Use [`API_RATELIMIT_IP_OVERRIDES`](https://docs.weblate.org/en/weblate-2026.10/admin/config.md#std-setting-API_RATELIMIT_IP_OVERRIDES) for individual IP
addresses or networks, including anonymous CI clients:

```python
API_RATELIMIT_USER_OVERRIDES = {"automation": "20000/hour"}
API_RATELIMIT_IP_OVERRIDES = {
    "192.0.2.42": None,
    "198.51.100.0/24": "10000/hour",
    "2001:db8::/48": "10000/hour",
}
```

An explicit username override takes precedence over IP rules. Otherwise, the
most specific matching network applies; an individual address is equivalent to
a single-address network. A value of `None` exempts matching requests from API
rate limits, including the anonymous limit. Authentication and permissions still
apply: an exemption does not grant access to private projects or write operations.

Limits are counted per authenticated user, or per client IP for anonymous
requests. Clients within a network do not share a single budget. Each override
rule and rate has a separate budget, so changing a rule or rate starts a new
budget. Requests without an override use the default limits.

IP rules use the client address resolved by Weblate. Behind a reverse proxy,
configure [`IP_BEHIND_REVERSE_PROXY`](https://docs.weblate.org/en/weblate-2026.10/admin/config.md#std-setting-IP_BEHIND_REVERSE_PROXY), [`IP_PROXY_HEADER`](https://docs.weblate.org/en/weblate-2026.10/admin/config.md#std-setting-IP_PROXY_HEADER), and
[`IP_PROXY_OFFSET`](https://docs.weblate.org/en/weblate-2026.10/admin/config.md#std-setting-IP_PROXY_OFFSET) correctly. The trusted proxy must supply the client
address, and untrusted clients must not be able to bypass it. Exempting a shared
proxy address can exempt all clients using that proxy.

In Docker, configure the equivalent JSON mappings using
[`WEBLATE_API_RATELIMIT_USER_OVERRIDES`](https://docs.weblate.org/en/weblate-2026.10/admin/install/docker.md#envvar-WEBLATE_API_RATELIMIT_USER_OVERRIDES) and
[`WEBLATE_API_RATELIMIT_IP_OVERRIDES`](https://docs.weblate.org/en/weblate-2026.10/admin/install/docker.md#envvar-WEBLATE_API_RATELIMIT_IP_OVERRIDES). Use JSON `null` for exemptions.

The status of rate limiting is reported in following headers:

| `X-RateLimit-Limit`     | Allowed number of requests to perform                |
|-------------------------|------------------------------------------------------|
| `X-RateLimit-Remaining` | Remaining number of requests to perform              |
| `X-RateLimit-Reset`     | Number of seconds until the rate-limit window resets |

Requests exempt from rate limiting do not include these headers.

#### Versionchanged
Changed in version 4.1: Added ratelimiting status headers.

#### SEE ALSO
* [Rate limiting](https://docs.weblate.org/en/weblate-2026.10/admin/optionals.md#rate-limit)
* [Rate limiting](https://docs.weblate.org/en/weblate-2026.10/user/translating.md#user-rate)
* [`WEBLATE_API_RATELIMIT_ANON`](https://docs.weblate.org/en/weblate-2026.10/admin/install/docker.md#envvar-WEBLATE_API_RATELIMIT_ANON)
* [`WEBLATE_API_RATELIMIT_USER`](https://docs.weblate.org/en/weblate-2026.10/admin/install/docker.md#envvar-WEBLATE_API_RATELIMIT_USER)

<a id="api-errors"></a>

### Error responses

#### Versionchanged
Changed in version 5.10: Error responses were endpoint specific before this release.

Weblate error responses are formatted based on [Error Response Format](https://drf-standardized-errors.readthedocs.io/en/latest/error_response.html).

## API Entry Point

### GET /api/

The API root entry point.

**Example request:**

```http
GET /api/ HTTP/1.1
Host: example.com
Accept: application/json, text/javascript
Authorization: Token YOUR-TOKEN
```

**Example response:**

```http
HTTP/1.0 200 OK
Date: Fri, 25 Mar 2016 09:46:12 GMT
Server: WSGIServer/0.1 Python/2.7.11+
Vary: Accept, Accept-Language, Cookie
X-Frame-Options: SAMEORIGIN
Content-Type: application/json
Content-Language: en
Allow: GET, HEAD, OPTIONS

{
    "projects":"http://example.com/api/projects/",
    "components":"http://example.com/api/components/",
    "translations":"http://example.com/api/translations/",
    "languages":"http://example.com/api/languages/"
}
```

<a id="api-users"></a>

## Users

#### Versionadded
Added in version 4.0.

### GET /api/users/

Returns no results to unauthenticated users. Authenticated users without the
global `user.view` or `user.edit` permission see only their own basic
details when listing without a username filter. They can search for other
users by supplying a username prefix of at least two characters after
trimming surrounding whitespace; these searches return the user ID,
username, and full name of matching non-bot users. Users with either
permission can list all users and receive detailed information.

* **Query Parameters:**
  * **username** (*string*) – Username prefix to search for. At least two characters after trimming surrounding whitespace are required for users without the global `user.view` or `user.edit` permission.
  * **id** (*int*) – User ID to search for
  * **email** (*string*) – Email to search for (case-insensitive, exact match). Requires `user.view` or `user.edit` permission; the parameter is ignored for unprivileged users.

Username searches by users without the global `user.view` or `user.edit`
permission exclude bot accounts other than the caller’s own account.

#### SEE ALSO
Users object attributes are documented at [`GET /api/users/(str:username)/`](#get--api-users-(str-username)-).

### POST /api/users/

Creates a new user.

Requires the global `user.edit` permission. See
[Access control](https://docs.weblate.org/en/weblate-2026.10/admin/access.md#access-control) for the user management permission model.

* **Parameters:**
  * **username** (*string*) – Username
  * **full_name** (*string*) – User full name
  * **email** (*string*) – User email
  * **is_superuser** (*boolean*) – Is user superuser? (optional)
  * **is_active** (*boolean*) – Is user active? (optional)
  * **is_bot** (*boolean*) – Is user bot? (optional) (used for project scoped tokens)

### GET /api/users/(*str:* username)/

Returns information about users.

* **Parameters:**
  * **username** (*string*) – User’s username
* **Response JSON Object:**
  * **username** (*string*) – username of a user
  * **full_name** (*string*) – full name of a user
  * **email** (*string*) – email of a user
  * **is_superuser** (*boolean*) – whether the user is a super user
  * **is_active** (*boolean*) – whether the user is active
  * **is_bot** (*boolean*) – whether the user is bot (used for project scoped tokens)
  * **date_joined** (*string*) – date the user is created
  * **last_login** (*string*) – date the user last signed in
  * **groups** (*array*) – link to associated groups; see [`GET /api/groups/(int:id)/`](#get--api-groups-(int-id)-)
  * **profile** (*object*) – user profile preferences; see [User profile](#api-user-profile). Returned only with the `user.view` or `user.edit` permission.

**Example JSON data:**

```json
{
    "email": "user@example.com",
    "full_name": "Example User",
    "username": "exampleusername",
    "groups": [
        "http://example.com/api/groups/2/",
        "http://example.com/api/groups/3/"
    ],
    "profile": {
        "language": "en",
        "languages": [
            "http://example.com/api/languages/cs/"
        ],
        "secondary_languages": [],
        "translated": 42,
        "suggested": 3,
        "uploaded": 1,
        "commented": 5,
        "theme": "auto",
        "hide_completed": false,
        "secondary_in_zen": true,
        "hide_source_secondary": false,
        "wide_tables": false,
        "listing_columns": ["untranslated", "untranslated_words", "untranslated_chars", "nottranslated", "checks", "suggestions", "comments"],
        "editor_link": "",
        "translate_mode": 0,
        "zen_mode": 0,
        "special_chars": "",
        "nearby_strings": 10,
        "auto_watch": true,
        "contribute_personal_tm": true,
        "dashboard_view": 1,
        "dashboard_component_list": null,
        "watched": [],
        "website": "https://example.com/",
        "contact": "",
        "liberapay": "",
        "fediverse": "",
        "codesite": "",
        "github": "",
        "twitter": "",
        "linkedin": "",
        "location": "",
        "company": "",
        "public_email": "",
        "commit_email": "",
        "commit_name": 0,
        "last_2fa": ""
    },
    "is_superuser": true,
    "is_active": true,
    "is_bot": false,
    "date_joined": "2020-03-29T18:42:42.617681Z",
    "url": "http://example.com/api/users/exampleusername/",
    "contributions_url": "http://example.com/api/users/exampleusername/contributions/",
    "statistics_url": "http://example.com/api/users/exampleusername/statistics/"
}
```

### PUT /api/users/(*str:* username)/

Changes the user parameters.

Requires the global `user.edit` permission unless a user is updating
their own account or profile fields. See [Access control](https://docs.weblate.org/en/weblate-2026.10/admin/access.md#access-control) for the user
management permission model.

* **Parameters:**
  * **username** (*string*) – User’s username
* **Response JSON Object:**
  * **username** (*string*) – username of a user
  * **full_name** (*string*) – full name of a user
  * **email** (*string*) – email of a user
  * **is_superuser** (*boolean*) – whether the user is a super user
  * **is_active** (*boolean*) – whether the user is active
  * **is_bot** (*boolean*) – whether the user is bot (used for project scoped tokens)
  * **date_joined** (*string*) – date the user is created
  * **profile** (*object*) – updated profile preferences when included in the request; see [User profile](#api-user-profile)

### PATCH /api/users/(*str:* username)/

Changes the user parameters.

Requires the global `user.edit` permission unless a user is updating
their own account or profile fields. See [Access control](https://docs.weblate.org/en/weblate-2026.10/admin/access.md#access-control) for the user
management permission model.

* **Parameters:**
  * **username** (*string*) – User’s username
* **Response JSON Object:**
  * **username** (*string*) – username of a user
  * **full_name** (*string*) – full name of a user
  * **email** (*string*) – email of a user
  * **is_superuser** (*boolean*) – whether the user is a super user
  * **is_active** (*boolean*) – whether the user is active
  * **is_bot** (*boolean*) – whether the user is bot (used for project scoped tokens)
  * **date_joined** (*string*) – date the user is created
  * **profile** (*object*) – updated profile preferences when included in the request; see [User profile](#api-user-profile)

### DELETE /api/users/(*str:* username)/

Deletes all user information and marks the user inactive.

Requires the global `user.edit` permission. See
[Access control](https://docs.weblate.org/en/weblate-2026.10/admin/access.md#access-control) for the user management permission model.

* **Parameters:**
  * **username** (*string*) – User’s username

### POST /api/users/(*str:* username)/groups/

Associate groups with a user.

Requires the global `user.edit` permission. See
[Access control](https://docs.weblate.org/en/weblate-2026.10/admin/access.md#access-control) for the user management permission model.
This permission authorizes membership changes for every team, including
project and workspace teams; no separate permission over the target team is
required.

* **Parameters:**
  * **username** (*string*) – User’s username
* **Form Parameters:**
  * **string group_id** – The unique group ID

### DELETE /api/users/(*str:* username)/groups/

#### Versionadded
Added in version 4.13.1.

Remove user from a group.

Requires the global `user.edit` permission. See
[Access control](https://docs.weblate.org/en/weblate-2026.10/admin/access.md#access-control) for the user management permission model.
This permission authorizes membership changes for every team, including
project and workspace teams; no separate permission over the target team is
required.

* **Parameters:**
  * **username** (*string*) – User’s username
* **Form Parameters:**
  * **string group_id** – The unique group ID

### GET /api/users/(*str:* username)/statistics/

List statistics of a user.

* **Parameters:**
  * **username** (*string*) – User’s username
* **Response JSON Object:**
  * **translated** (*int*) – Number of translations by user
  * **suggested** (*int*) – Number of suggestions by user
  * **uploaded** (*int*) – Number of uploads by user
  * **commented** (*int*) – Number of comments by user
  * **languages** (*int*) – Number of languages user can translate

### GET /api/users/(*str:* username)/contributions/

List translations with contributions from a user.

* **Parameters:**
  * **username** (*string*) – User’s username
* **Response JSON Object:**
  * **translations** (*array*) – link to translations; see [`GET /api/translations/(string:project)/(string:component)/(string:language)/`](#get--api-translations-(string-project)-(string-component)-(string-language)-)

### GET /api/users/(*str:* username)/notifications/

List subscriptions of a user.

* **Parameters:**
  * **username** (*string*) – User’s username
* **Response JSON Object:**
  * **project** (*string*) – Link to the project, or `null` for other scopes
  * **component** (*string*) – Link to the component, or `null` for other scopes

### POST /api/users/(*str:* username)/notifications/

Associate subscriptions with a user.

* **Parameters:**
  * **username** (*string*) – User’s username
* **Request JSON Object:**
  * **notification** (*string*) – Name of notification registered
  * **scope** (*int*) – Scope of notification from the available choices
  * **frequency** (*int*) – Frequency choices for notifications

### GET /api/users/(*str:* username)/notifications/(*int:* subscription_id)/

Get a subscription associated with a user.

* **Parameters:**
  * **username** (*string*) – User’s username
  * **subscription_id** (*int*) – ID of notification registered
* **Response JSON Object:**
  * **project** (*string*) – Link to the project, or `null` for other scopes
  * **component** (*string*) – Link to the component, or `null` for other scopes

### PUT /api/users/(*str:* username)/notifications/(*int:* subscription_id)/

Edit a subscription associated with a user.

* **Parameters:**
  * **username** (*string*) – User’s username
  * **subscription_id** (*int*) – ID of notification registered
* **Request JSON Object:**
  * **notification** (*string*) – Name of notification registered
  * **scope** (*int*) – Scope of notification from the available choices
  * **frequency** (*int*) – Frequency choices for notifications

### PATCH /api/users/(*str:* username)/notifications/(*int:* subscription_id)/

Edit a subscription associated with a user.

* **Parameters:**
  * **username** (*string*) – User’s username
  * **subscription_id** (*int*) – ID of notification registered
* **Request JSON Object:**
  * **notification** (*string*) – Name of notification registered
  * **scope** (*int*) – Scope of notification from the available choices
  * **frequency** (*int*) – Frequency choices for notifications

### DELETE /api/users/(*str:* username)/notifications/(*int:* subscription_id)/

Delete a subscription associated with a user.

* **Parameters:**
  * **username** (*string*) – User’s username
  * **subscription_id** – Name of notification registered
  * **subscription_id** – int

<a id="api-user-profile"></a>

## User profile

#### Versionadded
Added in version 2026.8.

The user API exposes profile preferences in a nested `profile` object. The
object is returned on [`GET /api/users/(str:username)/`](#get--api-users-(str-username)-) only for callers
with the `user.view` or `user.edit` permission. Users without those
permissions can still update their own profile through
[`PATCH /api/users/(str:username)/`](#patch--api-users-(str-username)-); the response then includes the updated
`profile` object.

Profile fields mirror the settings described in [User profile](https://docs.weblate.org/en/weblate-2026.10/user/profile.md#user-profile).

## Groups

#### Versionadded
Added in version 4.0.

Changing a site-wide group’s access scope requires the global `group.edit`
permission. This trusted administrative permission is not limited by the
caller’s project access: project and component association endpoints can grant
team members access to private projects the caller cannot access directly. See
[Site-wide team management](https://docs.weblate.org/en/weblate-2026.10/admin/access.md#site-wide-team-management) for the permission model and narrower
delegation options.

### GET /api/groups/

Returns a list of groups if you have permissions to see manage groups. If not, then you get to see
only the groups the user is a part of.

#### SEE ALSO
Group object attributes are documented at [`GET /api/groups/(int:id)/`](#get--api-groups-(int-id)-).

### POST /api/groups/

Creates a new group.

* **Parameters:**
  * **name** (*string*) – Group name
  * **project_selection** (*int*) – Group of project selection from given options
  * **language_selection** (*int*) – Group of languages selected from given options
  * **defining_project** (*str*) – link to the defining project, used for [Managing per-project access control](https://docs.weblate.org/en/weblate-2026.10/admin/access.md#manage-acl); see [`GET /api/projects/(string:project)/`](#get--api-projects-(string-project)-)

### GET /api/groups/(*int:* id)/

Returns information about the group.

* **Parameters:**
  * **id** (*int*) – Group’s ID
* **Response JSON Object:**
  * **name** (*string*) – name of a group
  * **project_selection** (*int*) – integer corresponding to group of projects
  * **language_selection** (*int*) – integer corresponding to group of languages
  * **roles** (*array*) – link to associated roles; see [`GET /api/roles/(int:id)/`](#get--api-roles-(int-id)-)
  * **projects** (*array*) – link to associated projects; see [`GET /api/projects/(string:project)/`](#get--api-projects-(string-project)-)
  * **components** (*array*) – link to associated components; see [`GET /api/components/(string:project)/(string:component)/`](#get--api-components-(string-project)-(string-component)-)
  * **componentlists** (*array*) – link to associated componentlist; see [`GET /api/component-lists/(str:slug)/`](#get--api-component-lists-(str-slug)-)
  * **defining_project** (*str*) – link to the defining project, used for [Managing per-project access control](https://docs.weblate.org/en/weblate-2026.10/admin/access.md#manage-acl); see [`GET /api/projects/(string:project)/`](#get--api-projects-(string-project)-)
  * **admins** (*array*) – link to associated administrators; see [`GET /api/users/(str:username)/`](#get--api-users-(str-username)-)

**Example JSON data:**

```json
{
    "name": "Guests",
    "defining_project": null,
    "project_selection": 3,
    "language_selection": 1,
    "url": "http://example.com/api/groups/1/",
    "roles": [
        "http://example.com/api/roles/1/",
        "http://example.com/api/roles/2/"
    ],
    "languages": [
        "http://example.com/api/languages/en/",
        "http://example.com/api/languages/cs/",
    ],
    "projects": [
        "http://example.com/api/projects/demo1/",
        "http://example.com/api/projects/demo/"
    ],
    "componentlist": "http://example.com/api/component-lists/new/",
    "components": [
        "http://example.com/api/components/demo/weblate/"
    ],
    "admins": [
        "http://example.com/api/users/exampleusername/"
    ]
}
```

### PUT /api/groups/(*int:* id)/

Changes the group parameters.

* **Parameters:**
  * **id** (*int*) – Group’s ID
* **Response JSON Object:**
  * **name** (*string*) – name of a group
  * **project_selection** (*int*) – integer corresponding to group of projects
  * **language_selection** (*int*) – integer corresponding to group of languages

### PATCH /api/groups/(*int:* id)/

Changes the group parameters.

* **Parameters:**
  * **id** (*int*) – Group’s ID
* **Response JSON Object:**
  * **name** (*string*) – name of a group
  * **project_selection** (*int*) – integer corresponding to group of projects
  * **language_selection** (*int*) – integer corresponding to group of languages

### DELETE /api/groups/(*int:* id)/

Deletes the group.

* **Parameters:**
  * **id** (*int*) – Group’s ID

### POST /api/groups/(*int:* id)/roles/

Associate roles with a group.

* **Parameters:**
  * **id** (*int*) – Group’s ID
* **Form Parameters:**
  * **string role_id** – The unique role ID

### DELETE /api/groups/(*int:* id)/roles/(*int:* role_id)

Delete role from a group.

* **Parameters:**
  * **id** (*int*) – Group’s ID
  * **role_id** (*int*) – The unique role ID

### POST /api/groups/(*int:* id)/components/

Associate components with a group.

* **Parameters:**
  * **id** (*int*) – Group’s ID
* **Form Parameters:**
  * **string component_id** – The unique component ID

### DELETE /api/groups/(*int:* id)/components/(*int:* component_id)

Delete component from a group.

* **Parameters:**
  * **id** (*int*) – Group’s ID
  * **component_id** (*int*) – The unique component ID

### POST /api/groups/(*int:* id)/projects/

Associate projects with a group.

* **Parameters:**
  * **id** (*int*) – Group’s ID
* **Form Parameters:**
  * **string project_id** – The unique project ID

### DELETE /api/groups/(*int:* id)/projects/(*int:* project_id)

Delete project from a group.

* **Parameters:**
  * **id** (*int*) – Group’s ID
  * **project_id** (*int*) – The unique project ID

### POST /api/groups/(*int:* id)/languages/

Associate languages with a group.

* **Parameters:**
  * **id** (*int*) – Group’s ID
* **Form Parameters:**
  * **string language_code** – The unique language code

### DELETE /api/groups/(*int:* id)/languages/(*string:* language_code)

Delete language from a group.

* **Parameters:**
  * **id** (*int*) – Group’s ID
  * **language_code** (*string*) – The unique language code

### POST /api/groups/(*int:* id)/componentlists/

Associate componentlists with a group.

* **Parameters:**
  * **id** (*int*) – Group’s ID
* **Form Parameters:**
  * **string component_list_id** – The unique componentlist ID

### DELETE /api/groups/(*int:* id)/componentlists/(*int:* component_list_id)

Delete componentlist from a group.

* **Parameters:**
  * **id** (*int*) – Group’s ID
  * **component_list_id** (*int*) – The unique componentlist ID

### POST /api/groups/(*int:* id)/admins/

#### Versionadded
Added in version 5.5.

Add user to team admins.

* **Parameters:**
  * **id** (*int*) – Group’s ID
* **Form Parameters:**
  * **string user_id** – The user’s ID

### DELETE /api/groups/(*int:* id)/admins/(*int:* user_id)

#### Versionadded
Added in version 5.5.

Delete user from team admins.

* **Parameters:**
  * **id** (*int*) – Group’s ID
  * **user_id** (*integer*) – The user’s ID

## Roles

### GET /api/roles/

Returns a list of all roles associated with user. If user is superuser, then list of all
existing roles is returned.

#### SEE ALSO
Roles object attributes are documented at [`GET /api/roles/(int:id)/`](#get--api-roles-(int-id)-).

### POST /api/roles/

Creates a new role.

* **Parameters:**
  * **name** (*string*) – Role name
  * **permissions** (*array*) – List of codenames of permissions

### GET /api/roles/(*int:* id)/

Returns information about the role.

* **Parameters:**
  * **id** (*int*) – Role’s ID
* **Response JSON Object:**
  * **name** (*string*) – Role name
  * **permissions** (*array*) – list of codenames of permissions

**Example JSON data:**

```json
{
    "name": "Access repository",
    "permissions": [
        "vcs.access",
        "vcs.view"
    ],
    "url": "http://example.com/api/roles/1/",
}
```

### PUT /api/roles/(*int:* id)/

Changes the role parameters.

* **Parameters:**
  * **id** (*int*) – Role’s ID
* **Response JSON Object:**
  * **name** (*string*) – Role name
  * **permissions** (*array*) – list of codenames of permissions

### PATCH /api/roles/(*int:* id)/

Changes the role parameters.

* **Parameters:**
  * **id** (*int*) – Role’s ID
* **Response JSON Object:**
  * **name** (*string*) – Role name
  * **permissions** (*array*) – list of codenames of permissions

### DELETE /api/roles/(*int:* id)/

Deletes the role.

* **Parameters:**
  * **id** (*int*) – Role’s ID

## Languages

### GET /api/languages/

Returns a list of all languages.

#### SEE ALSO
Language object attributes are documented at [`GET /api/languages/(string:language)/`](#get--api-languages-(string-language)-).

### POST /api/languages/

Creates a new language.

* **Parameters:**
  * **code** (*string*) – Language name
  * **name** (*string*) – Language name
  * **direction** (*string*) – Text direction
  * **population** (*int*) – Number of speakers
  * **plural** (*object*) – Language plural formula and number

### GET /api/languages/(*string:* language)/

Returns information about the language.

* **Parameters:**
  * **language** (*string*) – Language code
* **Response JSON Object:**
  * **code** (*string*) – Language code
  * **direction** (*string*) – Text direction
  * **plural** (*object*) – Object of language plural information
  * **aliases** (*array*) – Array of aliases for language
* **Request JSON Object:**
  * **population** (*int*) – Number of speakers

**Example JSON data:**

```json
{
    "code": "en",
    "direction": "ltr",
    "name": "English",
    "population": 159034349015,
    "plural": {
        "id": 75,
        "source": 0,
        "number": 2,
        "formula": "n != 1",
        "type": 1
    },
    "aliases": [
        "english",
        "en_en",
        "base",
        "source",
        "eng"
    ],
    "url": "http://example.com/api/languages/en/",
    "web_url": "http://example.com/languages/en/",
    "statistics_url": "http://example.com/api/languages/en/statistics/"
}
```

### PUT /api/languages/(*string:* language)/

Changes the language parameters.

* **Parameters:**
  * **language** (*string*) – Language’s code
* **Request JSON Object:**
  * **name** (*string*) – Language name
  * **direction** (*string*) – Text direction
  * **population** (*int*) – Number of speakers
  * **plural** (*object*) – Language plural details

### PATCH /api/languages/(*string:* language)/

Changes the language parameters.

* **Parameters:**
  * **language** (*string*) – Language’s code
* **Request JSON Object:**
  * **name** (*string*) – Language name
  * **direction** (*string*) – Text direction
  * **population** (*int*) – Number of speakers
  * **plural** (*object*) – Language plural details

### DELETE /api/languages/(*string:* language)/

Deletes the language.

* **Parameters:**
  * **language** (*string*) – Language’s code

### GET /api/languages/(*string:* language)/statistics/

Returns statistics for a language.

* **Parameters:**
  * **language** (*string*) – Language code

#### SEE ALSO
Returned attributes are described in [Statistics](#api-statistics).

## Projects

### GET /api/projects/

Returns a list of all projects.

#### SEE ALSO
Project object attributes are documented at [`GET /api/projects/(string:project)/`](#get--api-projects-(string-project)-).

### POST /api/projects/

Creates a new project.

* **Parameters:**
  * **name** (*string*) – Project name
  * **slug** (*string*) – Project slug
  * **web** (*string*) – Project website
  * **workspace** (*string*) – Optional workspace UUID. Creating a project in a workspace
    requires Add projects to workspace permission
    for that workspace. When omitted, Weblate can use the
    only eligible workspace. Creating a project without an
    eligible workspace requires the site-wide
    Add new projects permission. See
    [Project creation and moves](https://docs.weblate.org/en/weblate-2026.10/admin/workspaces.md#workspace-project-creation).
  * **access_control** (*integer*) – [Access control](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#project-access-control)
  * **public_sharing** (*boolean*) – [Public sharing](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#project-public-sharing)
  * **use_shared_tm** (*boolean*) – [Use shared translation memory](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#project-use-shared-tm)
  * **contribute_shared_tm** (*boolean*) – [Contribute to shared translation memory](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#project-contribute-shared-tm)
  * **use_workspace_tm** (*boolean*) – [Use workspace translation memory](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#project-use-workspace-tm)
  * **contribute_workspace_tm** (*boolean*) – [Contribute to workspace translation memory](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#project-contribute-workspace-tm)
  * **autoclean_tm** (*boolean*) – [Autoclean translation memory](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#project-autoclean-tm)

Omit `access_control` to use the configured default. Explicit non-default
access control requires a superuser unless a billing plan determines the
value. On Hosted Weblate, Custom access control is unavailable and each
translation-memory contribution setting is forced to match its
corresponding usage setting.

### GET /api/projects/(*string:* project)/

Returns information about the project.

* **Parameters:**
  * **project** (*string*) – Project URL slug
* **Response JSON Object:**
  * **name** (*string*) – project name
  * **slug** (*string*) – project slug
  * **web** (*string*) – project website
  * **components_list_url** (*string*) – URL to components list; see [`GET /api/projects/(string:project)/components/`](#get--api-projects-(string-project)-components-)
  * **repository_url** (*string*) – URL to repository status; see [`GET /api/projects/(string:project)/repository/`](#get--api-projects-(string-project)-repository-)
  * **changes_list_url** (*string*) – URL to changes list; see [`GET /api/projects/(string:project)/changes/`](#get--api-projects-(string-project)-changes-)
  * **reports_url** (*string*) – URL to list or generate scoped reports; see [`GET /api/projects/(string:project)/reports/`](#get--api-projects-(string-project)-reports-)
  * **translation_review** (*boolean*) – [Enable reviews](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#project-translation-review)
  * **source_review** (*boolean*) – [Enable source reviews](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#project-source-review)
  * **enable_hooks** (*boolean*) – [Enable hooks](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#project-enable-hooks)
  * **workspace** (*string*) – workspace UUID, or `null` when the project is not
    assigned to a workspace
  * **instructions** (*string*) – [Translation instructions](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#project-instructions)
  * **language_aliases** (*string*) – [Language aliases](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#project-language-aliases)
  * **license** (*string*) – [Translation license](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#project-license)
  * **enforced_checks** (*array*) – Locally configured [enforced checks](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#component-enforced-checks).
  * **inherit_enforced_checks** (*boolean*) – Whether enforced checks are inherited from the workspace.
  * **effective_enforced_checks** (*array*) – Enforced checks currently applied to the project (read-only).
  * **access_control** (*integer*) – [Access control](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#project-access-control)
  * **public_sharing** (*boolean*) – [Public sharing](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#project-public-sharing)
  * **use_shared_tm** (*boolean*) – [Use shared translation memory](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#project-use-shared-tm)
  * **contribute_shared_tm** (*boolean*) – [Contribute to shared translation memory](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#project-contribute-shared-tm)
  * **use_workspace_tm** (*boolean*) – [Use workspace translation memory](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#project-use-workspace-tm)
  * **contribute_workspace_tm** (*boolean*) – [Contribute to workspace translation memory](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#project-contribute-workspace-tm)
  * **autoclean_tm** (*boolean*) – [Autoclean translation memory](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#project-autoclean-tm)
  * **announcements_url** (*string*) – URL to announcements; see [`GET /api/projects/(string:project)/announcements/`](#get--api-projects-(string-project)-announcements-)

**Example JSON data:**

```json
{
    "name": "Hello",
    "slug": "hello",
    "url": "http://example.com/api/projects/hello/",
    "web": "https://weblate.org/",
    "web_url": "http://example.com/projects/hello/"
}
```

### GET /api/projects/(*string:* project)/languages/(*string:* language)/workflow/

Return project-language workflow settings. When no project override exists,
return inherited site-wide workflow settings, or defaults when none exist,
without creating an override. Reviews remain disabled when both project
review settings are disabled. The language is identified by its code.
Access to the project is required.

* **Response JSON Object:**
  * **language** (*string*) – Language code (read-only)
  * **source_language** (*string*) – Custom source language code, or null for the component source; see [Custom source language](https://docs.weblate.org/en/weblate-2026.10/workflows.md#workflow-source-language)
  * **translation_review** (*boolean*) – Enable translation review
  * **enable_suggestions** (*boolean*) – Enable suggestions
  * **restrict_direct_editing** (*boolean*) – Require suggestions instead of direct editing
  * **suggestion_voting** (*boolean*) – Enable voting on suggestions
  * **suggestion_autoaccept** (*integer*) – Number of votes required to accept suggestions, or 0 to disable

### PATCH /api/projects/(*string:* project)/languages/(*string:* language)/workflow/

Create or update a project-language workflow override. Requires permission
to edit the project. Accepts the writable fields returned by
[`GET /api/projects/(string:project)/languages/(string:language)/workflow/`](#get--api-projects-(string-project)-languages-(string-language)-workflow-).
Omitted fields retain their values, including inherited workflow settings
when creating an override. Enabling reviews requires source or translation
reviews to be enabled on the project. Set `source_language` to null to use
the component source. Source languages must exist in the project and must
not form a dependency cycle. Changes reconcile affected units before the
request completes.

### DELETE /api/projects/(*string:* project)/languages/(*string:* language)/workflow/

Remove the project-language workflow override, restoring inherited settings.
Requires permission to edit the project. Returns HTTP 204, including when
no override exists.

All three methods return HTTP 409 if legacy data contains multiple workflow
overrides for the same project and language. Resolve the duplicate settings
before using this endpoint; the API does not choose or delete them implicitly.

### PATCH /api/projects/(*string:* project)/

#### Versionadded
Added in version 4.3.

Edit a project by a [PATCH](https://www.rfc-editor.org/rfc/rfc5789#section-2) request.

The `project` value is the project slug. To avoid using a wrong
identifier, use the project `url` returned by [`GET /api/projects/`](#get--api-projects-)
or [`GET /api/projects/(string:project)/`](#get--api-projects-(string-project)-).

The request body accepts project fields such as `instructions`,
`license`, `access_control`, and translation-memory settings.

**Example JSON data:**

```json
{
    "instructions": "Translate consistently.",
    "license": "MIT",
    "use_shared_tm": true,
    "access_control": 100
}
```

Changing `access_control` or `public_sharing` requires permission to
manage project access.
Making a project publicly accessible can require licenses on its components
when [`LICENSE_REQUIRED`](https://docs.weblate.org/en/weblate-2026.10/admin/config.md#std-setting-LICENSE_REQUIRED) is enabled. On Hosted Weblate, Custom
access control is unavailable and each translation-memory contribution
setting is forced to match its corresponding usage setting.

Changing `workspace` moves the project. Moving a project requires
permission to edit the project and the Edit workspace settings
permission for the source and target workspace. The target workspace also
requires the Add projects to workspace permission. Moving a
project out of a workspace also requires the site-wide Add new
projects permission. See [Project creation and moves](https://docs.weblate.org/en/weblate-2026.10/admin/workspaces.md#workspace-project-creation).

* **Parameters:**
  * **project** (*string*) – Project URL slug
  * **instructions** (*string*) – [Translation instructions](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#project-instructions)
  * **license** (*string*) – [Translation license](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#project-license)
  * **access_control** (*integer*) – [Access control](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#project-access-control)
  * **public_sharing** (*boolean*) – [Public sharing](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#project-public-sharing)
  * **use_shared_tm** (*boolean*) – [Use shared translation memory](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#project-use-shared-tm)
  * **contribute_shared_tm** (*boolean*) – [Contribute to shared translation memory](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#project-contribute-shared-tm)
  * **use_workspace_tm** (*boolean*) – [Use workspace translation memory](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#project-use-workspace-tm)
  * **contribute_workspace_tm** (*boolean*) – [Contribute to workspace translation memory](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#project-contribute-workspace-tm)
  * **autoclean_tm** (*boolean*) – [Autoclean translation memory](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#project-autoclean-tm)
  * **workspace** (*string*) – Optional workspace UUID, or `null` to move the project
    out of a workspace

### PUT /api/projects/(*string:* project)/

#### Versionadded
Added in version 4.3.

Edit a project by a [PUT](https://www.rfc-editor.org/rfc/rfc7231#section-4.3.4) request.

Changing `workspace` follows the same permission checks as
[`PATCH /api/projects/(string:project)/`](#patch--api-projects-(string-project)-).

* **Parameters:**
  * **project** (*string*) – Project URL slug
  * **instructions** (*string*) – [Translation instructions](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#project-instructions)
  * **license** (*string*) – [Translation license](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#project-license)
  * **access_control** (*integer*) – [Access control](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#project-access-control)
  * **public_sharing** (*boolean*) – [Public sharing](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#project-public-sharing)
  * **use_shared_tm** (*boolean*) – [Use shared translation memory](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#project-use-shared-tm)
  * **contribute_shared_tm** (*boolean*) – [Contribute to shared translation memory](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#project-contribute-shared-tm)
  * **use_workspace_tm** (*boolean*) – [Use workspace translation memory](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#project-use-workspace-tm)
  * **contribute_workspace_tm** (*boolean*) – [Contribute to workspace translation memory](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#project-contribute-workspace-tm)
  * **autoclean_tm** (*boolean*) – [Autoclean translation memory](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#project-autoclean-tm)

### DELETE /api/projects/(*string:* project)/

Deletes a project.

* **Parameters:**
  * **project** (*string*) – Project URL slug

### GET /api/projects/(*string:* project)/changes/

Returns a list of project changes. This is essentially a project scoped
[`GET /api/changes/`](#get--api-changes-) accepting same params.

* **Parameters:**
  * **project** (*string*) – Project URL slug
* **Response JSON Object:**
  * **results** (*array*) – array of component objects; see [`GET /api/changes/(int:id)/`](#get--api-changes-(int-id)-)

### GET /api/projects/(*string:* project)/file/

#### Versionadded
Added in version 5.5.

Downloads all available translations associated with the project as an archive file using the requested format and language. An unfiltered archive requires project-wide download permission. When `language_code` is specified, download permission is evaluated for that language.

* **Parameters:**
  * **project** (*string*) – Project URL slug
* **Query Parameters:**
  * **format** (*string*) – The archive format to use; If not specified, defaults to `zip`; Supported formats: `zip` and `zip:CONVERSION` where `CONVERSION` is one of converters listed at [Downloading translations](https://docs.weblate.org/en/weblate-2026.10/user/files.md#download).
  * **language_code** (*string*) – The language code to download; If not specified, all languages are included.

### GET /api/projects/(*string:* project)/repository/

Returns information about the VCS repository status. This endpoint contains
only an overall summary for all repositories for the project. To get more detailed
status use [`GET /api/components/(string:project)/(string:component)/repository/`](#get--api-components-(string-project)-(string-component)-repository-).

Repository status includes repositories where the user has a VCS permission
on the component owning that repository. Repositories whose owners do not
grant this permission are omitted and reported separately.

* **Parameters:**
  * **project** (*string*) – Project URL slug
* **Response JSON Object:**
  * **needs_commit** (*boolean*) – whether there are any pending changes to commit
  * **needs_merge** (*boolean*) – whether there are any upstream changes to merge
  * **needs_push** (*boolean*) – whether there are any local changes to push
  * **included_components** (*array*) – full paths of project components included in the status
  * **skipped_components** (*array*) – full paths of project components omitted from the status
  * **permission_blockers** (*array*) – full paths of components preventing access to omitted repositories

**Example JSON data:**

```json
{
    "included_components": ["hello/app"],
    "needs_commit": true,
    "needs_merge": false,
    "needs_push": true,
    "permission_blockers": ["shared/glossary"],
    "skipped_components": ["hello/glossary"]
}
```

### POST /api/projects/(*string:* project)/repository/

Performs given operation on the VCS repository.

Repository operations process repositories where the user has the requested
VCS permission on the component owning that repository. Repositories
whose owners do not grant this permission are skipped. The request is
denied when no repository is eligible for the operation.

* **Parameters:**
  * **project** (*string*) – Project URL slug
* **Request JSON Object:**
  * **operation** (*string*) – Operation to perform: one of `push`, `pull`, `commit`, `reset`, `cleanup`, `file-sync`, `file-scan`
  * **background** (*boolean*) – Schedule the operation as a background task instead of waiting for it to finish. Defaults to `false`.
* **Response JSON Object:**
  * **result** (*boolean*) – result of a synchronous operation
  * **included_components** (*array*) – full paths of project components included in the operation
  * **skipped_components** (*array*) – full paths of project components omitted from the operation
  * **permission_blockers** (*array*) – full paths of components preventing access to omitted repositories
  * **detail** (*string*) – Status of a background operation
  * **task_url** (*string*) – URL for tracking a background operation; see [`GET /api/tasks/(str:uuid)/`](#get--api-tasks-(str-uuid)-)

With `background` set to `true`, the endpoint returns `202 Accepted`.
Repeating an identical queued operation returns the existing task URL. A
conflicting operation returns `423 Locked` and the active task URL when
available. Eligible project repositories are processed sequentially in one
task.

**CURL example:**

```sh
curl \
    -d operation=pull \
    -H "Authorization: Token TOKEN" \
    http://example.com/api/projects/hello/repository/
```

**JSON request example:**

```http
POST /api/projects/hello/repository/ HTTP/1.1
Host: example.com
Accept: application/json
Content-Type: application/json
Authorization: Token TOKEN
Content-Length: 20

{"operation":"pull"}
```

**JSON response example:**

```http
HTTP/1.0 200 OK
Date: Tue, 12 Apr 2016 09:32:50 GMT
Server: WSGIServer/0.1 Python/2.7.11+
Vary: Accept, Accept-Language, Cookie
X-Frame-Options: SAMEORIGIN
Content-Type: application/json
Content-Language: en
Allow: GET, POST, HEAD, OPTIONS

{
    "included_components": ["hello/app"],
    "permission_blockers": ["shared/glossary"],
    "result": true,
    "skipped_components": ["hello/glossary"]
}
```

**Background JSON request example:**

```http
POST /api/projects/hello/repository/ HTTP/1.1
Host: example.com
Accept: application/json
Content-Type: application/json
Authorization: Token TOKEN

{"operation":"pull","background":true}
```

**Background JSON response example:**

```http
HTTP/1.0 202 Accepted
Content-Type: application/json

{
    "detail": "Repository operation has been queued.",
    "included_components": ["hello/app"],
    "permission_blockers": ["shared/glossary"],
    "skipped_components": ["hello/glossary"],
    "task_url": "https://example.com/api/tasks/01234567-89ab-cdef-0123-456789abcdef/"
}
```

### GET /api/projects/(*string:* project)/components/

Returns a list of translation components in the given project.

* **Parameters:**
  * **project** (*string*) – Project URL slug
* **Response JSON Object:**
  * **results** (*array*) – array of component objects; see [`GET /api/components/(string:project)/(string:component)/`](#get--api-components-(string-project)-(string-component)-)

### POST /api/projects/(*string:* project)/components/

#### Versionchanged
Changed in version 4.3: The `zipfile` and `docfile` parameters are now accepted for VCS-less components, see [Local files](https://docs.weblate.org/en/weblate-2026.10/vcs.md#vcs-local).

#### Versionchanged
Changed in version 4.6: The cloned repositories are now automatically shared within a project using [Weblate internal URLs](https://docs.weblate.org/en/weblate-2026.10/vcs.md#internal-urls). Use `disable_autoshare` to turn off this.

Creates translation components in the given project.

#### HINT
Use [Weblate internal URLs](https://docs.weblate.org/en/weblate-2026.10/vcs.md#internal-urls) when creating multiple components from a single VCS repository.

#### NOTE
Most of the component creation happens in the background. Check the
`task_url` attribute of created component and follow the progress
there.

* **Parameters:**
  * **project** (*string*) – Project URL slug
* **Form Parameters:**
  * **file zipfile** – ZIP file to upload into Weblate for translations initialization
  * **file docfile** – Document to translate
  * **string from_component** – Optional source component reference used to duplicate the new component. Accepts either a numeric component ID or a full Weblate component path. When provided, the new component inherits the source component configuration and translations into a new local repository. Repository fields such as `repo`, `vcs`, `branch`, `push`, and `push_branch` can not be combined with this option.
  * **boolean disable_autoshare** – Disables automatic repository sharing via [Weblate internal URLs](https://docs.weblate.org/en/weblate-2026.10/vcs.md#internal-urls).
* **Request JSON Object:**
  * **object** – Component parameters, see [`GET /api/components/(string:project)/(string:component)/`](#get--api-components-(string-project)-(string-component)-)
* **Response JSON Object:**
  * **result** (*object*) – Created component object; see [`GET /api/components/(string:project)/(string:component)/`](#get--api-components-(string-project)-(string-component)-)

JSON can not be used when uploading the files using the `zipfile` and
`docfile` parameters. The data has to be uploaded as
*multipart/form-data*.

**CURL form request example:**

```sh
curl \
    --form docfile=@strings.html \
    --form name=Weblate \
    --form slug=weblate \
    --form file_format=html \
    --form new_lang=add \
    -H "Authorization: Token TOKEN" \
    http://example.com/api/projects/hello/components/
```

**CURL JSON request example:**

```sh
curl \
    --data-binary '{
        "branch": "main",
        "file_format": "po",
        "file_format_params": {
            "po_line_wrap": 65535,
            "po_no_location": true
        },
        "filemask": "po/*.po",
        "name": "Weblate",
        "slug": "weblate",
        "repo": "https://github.com/WeblateOrg/hello.git",
        "template": "",
        "new_base": "po/hello.pot",
        "vcs": "git"
    }' \
    -H "Content-Type: application/json" \
    -H "Authorization: Token TOKEN" \
    http://example.com/api/projects/hello/components/
```

**JSON request to create a new component from Git:**

```http
POST /api/projects/hello/components/ HTTP/1.1
Host: example.com
Accept: application/json
Content-Type: application/json
Authorization: Token TOKEN
Content-Length: 20

{
    "branch": "main",
    "file_format": "po",
    "file_format_params": {
        "po_line_wrap": 65535,
        "po_no_location": true
    },
    "filemask": "po/*.po",
    "name": "Weblate",
    "slug": "weblate",
    "repo": "https://github.com/WeblateOrg/hello.git",
    "template": "",
    "new_base": "po/hello.pot",
    "vcs": "git"
}
```

**JSON request to create a new component from another one:**

```http
POST /api/projects/hello/components/ HTTP/1.1
Host: example.com
Accept: application/json
Content-Type: application/json
Authorization: Token TOKEN
Content-Length: 20

{
    "from_component": "hello/weblate",
    "name": "Weblate",
    "slug": "weblate"
}
```

**JSON response example:**

```http
HTTP/1.0 200 OK
Date: Tue, 12 Apr 2016 09:32:50 GMT
Server: WSGIServer/0.1 Python/2.7.11+
Vary: Accept, Accept-Language, Cookie
X-Frame-Options: SAMEORIGIN
Content-Type: application/json
Content-Language: en
Allow: GET, POST, HEAD, OPTIONS

{
    "branch": "main",
    "file_format": "po",
    "file_format_params": {
        "po_line_wrap": 65535,
        "po_no_location": true
    },
    "filemask": "po/*.po",
    "git_export": "",
    "license": "",
    "license_url": "",
    "name": "Weblate",
    "slug": "weblate",
    "project": {
        "name": "Hello",
        "slug": "hello",
        "source_language": {
            "code": "en",
            "direction": "ltr",
             "population": 159034349015,
            "name": "English",
            "url": "http://example.com/api/languages/en/",
            "web_url": "http://example.com/languages/en/"
        },
        "url": "http://example.com/api/projects/hello/",
        "web": "https://weblate.org/",
        "web_url": "http://example.com/projects/hello/"
    },
    "repo": "file:///home/nijel/work/weblate-hello",
    "template": "",
    "new_base": "",
    "url": "http://example.com/api/components/hello/weblate/",
    "vcs": "git",
    "web_url": "http://example.com/projects/hello/weblate/"
}
```

### GET /api/projects/(*string:* project)/languages/

Returns paginated statistics for all languages within a project.

* **Parameters:**
  * **project** (*string*) – Project URL slug
* **Response JSON Object:**
  * **results** (*array*) – array of translation statistics objects
  * **language** (*string*) – language name
  * **code** (*string*) – language code
  * **total** (*int*) – total number of strings
  * **translated** (*int*) – number of translated strings
  * **translated_percent** (*float*) – percentage of translated strings
  * **total_words** (*int*) – total number of words
  * **translated_words** (*int*) – number of translated words
  * **words_percent** (*float*) – percentage of translated words

### GET /api/projects/(*string:* project)/statistics/

Returns statistics for a project.

* **Parameters:**
  * **project** (*string*) – Project URL slug

#### SEE ALSO
Returned attributes are described in [Statistics](#api-statistics).

### GET /api/projects/(*string:* project)/metrics/

#### Versionadded
Added in version 2026.8.

Returns translation metrics for the project components visible to the
caller. Components are identified by their project-relative path and the
result is grouped by component and language. When multiple components have
the same project-relative path, `@` and the component ID are appended to
each colliding path.

The OpenMetrics representation exposes `weblate_translation_info` and
`weblate_*` gauges compatible with the project translation statistics.
Strings containing suggestions use
`weblate_strings_with_suggestions` to distinguish them from the
server-wide `weblate_suggestions` object count.
The CSV representation contains one row for each component, language, and
numeric metric.

* **Parameters:**
  * **project** (*string*) – Project URL slug
* **Query Parameters:**
  * **format** (*string*) – Response format; use `openmetrics` or `csv` for
    monitoring and tabular output.

### GET /api/projects/(*string:* project)/categories/

#### Versionadded
Added in version 5.0: Returns categories for a project. See [`GET /api/categories/(int:id)/`](#get--api-categories-(int-id)-) for field definitions.

* **param project:**
  Project URL slug
* **type project:**
  string

### GET /api/projects/(*string:* project)/labels/

#### Versionadded
Added in version 5.3: Returns labels for a project.

* **param project:**
  Project URL slug
* **type project:**
  string
* **>json int id:**
  ID of the label
* **>json string name:**
  name of the label
* **>json string color:**
  color of the label

### POST /api/projects/(*string:* project)/labels/

#### Versionadded
Added in version 5.3: Creates a label for a project. The label color is required.

* **param project:**
  Project URL slug
* **type project:**
  string
* **<json string name:**
  name of the label
* **<json string color:**
  color of the label

### DELETE /api/projects/(*string:* project)/labels/(*int:* label_id)/

#### Versionadded
Added in version 5.14: Deletes a label from a project.

* **param project:**
  Project URL slug
* **type project:**
  string
* **param label_id:**
  ID of the label to delete
* **type label_id:**
  integer

### GET /api/projects/(*string:* project)/reports/

Lists accessible reports generated directly for a project.

### POST /api/projects/(*string:* project)/reports/

Schedules a report using the project as its scope. The request and response
match [`POST /api/reports/`](#post--api-reports-); scope fields must be omitted.

### GET /api/projects/(*string:* project)/machinery_settings/

#### Versionadded
Added in version 5.9.

Returns automatic suggestion settings for a project, consisting of the configurations defined for each translation service installed.

* **Parameters:**
  * **project** (*string*) – Project URL slug
* **Response JSON Object:**
  * **suggestion_settings** (*object*) – Configuration for all installed services.

### POST /api/projects/(*string:* project)/machinery_settings/

#### Versionadded
Added in version 5.9.

Create or update the service configuration for a project.

* **Parameters:**
  * **project** (*string*) – Project URL slug
* **Form Parameters:**
  * **string service** – Service name
  * **string configuration** – Service configuration in JSON

### GET /api/projects/(*string:* project)/languages/(*string:* language_code)/file/

#### Versionchanged
Changed in version 5.15.1: Added ability to download ZIP file of all components translations in a project for 1 specific language.

Download a ZIP file of all translation files for a specified `language_code` across all components for a given `project` rather than downloading individual translated files and manually zipping them, with the archive named {project-slug}-{language-code}.zip and organized by component paths (e.g., component-slug/po/lang.po). Download permission is evaluated for the requested language.

* **Parameters:**
  * **project** (*string*) – Project URL slug
  * **language_code** (*string*) – Language code
* **Query Parameters:**
  * **filter** (*string*) – Optional case-insensitive substring to filter components by slug (e.g., `?filter=core` will match components with ‘core’ anywhere in their slug); only components whose slugs contain the substring will be included in the download.
  * **format** (*string*) – The archive format to use; If not specified, defaults to `zip`; Supported formats: `zip` and `zip:CONVERSION` where `CONVERSION` is one of converters listed at [Downloading translations](https://docs.weblate.org/en/weblate-2026.10/user/files.md#download).

#### NOTE
Possible responses:

- `200 OK` with the ZIP file of translations for the specified language across all components in the project. If no components have translations for the specified language, an empty ZIP file will be returned.
- `403 Forbidden` if the user does not have download permission for the requested language.
- `404 Not Found` if the project slug or language code does not exist.

### GET /api/projects/(*string:* project)/languages/(*string:* language_code)/announcements/

#### Versionadded
Added in version 2026.6: Returns announcements for a specified `language_code` in a project.

* **param project:**
  Project URL slug
* **type project:**
  string
* **param language_code:**
  Language code
* **type language_code:**
  string
* **>json int id:**
  ID of the announcement
* **>json string message:**
  announcement text
* **>json string severity:**
  color of the message, one of `info` (light blue), `warning` (yellow), `danger` (red), `success` (green)
* **>json date expiry:**
  hide after this date, ISO 8601 extended format date (optional)
* **>json bool notify:**
  send notification to subscribed users? (optional)

### POST /api/projects/(*string:* project)/languages/(*string:* language_code)/announcements/

#### Versionadded
Added in version 2026.6: Creates an announcement for a specified `language_code` in a project.

* **param project:**
  Project URL slug
* **type project:**
  string
* **param language_code:**
  Language code
* **type language_code:**
  string
* **<json string message:**
  announcement text
* **<json string severity:**
  color of the message, one of `info` (light blue), `warning` (yellow), `danger` (red), `success` (green)
* **<json date expiry:**
  hide after this date, ISO 8601 extended format date (optional)
* **<json bool notify:**
  send notification to subscribed users? (optional)

### DELETE /api/projects/(*string:* project)/languages/(*string:* language_code)/announcements/(*int:* announcement_id)/

#### Versionadded
Added in version 2026.6: Deletes an announcement from a specified `language_code` in a project.

* **param project:**
  Project URL slug
* **type project:**
  string
* **param language_code:**
  Language code
* **type language_code:**
  string
* **param announcement_id:**
  ID of the announcement to delete
* **type announcement_id:**
  integer

### GET /api/projects/(*string:* project)/announcements/

#### Versionadded
Added in version 5.17: Returns announcements for a project.

* **param project:**
  Project URL slug
* **type project:**
  string
* **>json int id:**
  ID of the announcement
* **>json string message:**
  announcement text
* **>json string severity:**
  color of the message, one of `info` (light blue), `warning` (yellow), `danger` (red), `success` (green)
* **>json date expiry:**
  hide after this date, ISO 8601 extended format date (optional)
* **>json bool notify:**
  send notification to subscribed users? (optional)

### POST /api/projects/(*string:* project)/announcements/

#### Versionadded
Added in version 5.17: Creates an announcement for a project.

* **param project:**
  Project URL slug
* **type project:**
  string
* **<json string message:**
  announcement text
* **<json string severity:**
  color of the message, one of `info` (light blue), `warning` (yellow), `danger` (red), `success` (green)
* **<json date expiry:**
  hide after this date, ISO 8601 extended format date (optional)
* **<json bool notify:**
  send notification to subscribed users? (optional)

### DELETE /api/projects/(*string:* project)/announcements/(*int:* announcement_id)/

#### Versionadded
Added in version 5.17: Deletes an announcement from a project.

* **param project:**
  Project URL slug
* **type project:**
  string
* **param announcement_id:**
  ID of the announcement to delete
* **type announcement_id:**
  integer

### GET /api/projects/(*string:* project)/backups/

#### Versionadded
Added in version 2026.7: Returns a list of [Project level backups](https://docs.weblate.org/en/weblate-2026.10/admin/backup.md#projectbackup) archives. Project backups contain all
project components, including restricted components, and require
Edit project settings.

* **param project:**
  Project URL slug
* **type project:**
  string
* **>json string name:**
  Backup file name, for example `1718803200.zip`
* **>json string timestamp:**
  Backup creation time in ISO 8601 format
* **>json int size:**
  Backup file size in bytes

### POST /api/projects/(*string:* project)/backups/

#### Versionadded
Added in version 2026.7: Schedules creation of a new [Project level backups](https://docs.weblate.org/en/weblate-2026.10/admin/backup.md#projectbackup) archive. Once ready, the backup appears in
[`GET /api/projects/(string:project)/backups/`](#get--api-projects-(string-project)-backups-).

* **param project:**
  Project URL slug
* **type project:**
  string
* **>json string detail:**
  Result message
* **>json string url:**
  URL to list backups

### GET /api/projects/(*string:* project)/backups/(*string:* backup)/

#### Versionadded
Added in version 2026.7: Downloads a [Project level backups](https://docs.weblate.org/en/weblate-2026.10/admin/backup.md#projectbackup) archive containing all project components,
including restricted components. This requires Edit project
settings.

* **param project:**
  Project URL slug
* **type project:**
  string
* **param backup:**
  Backup file name, e.g. `1718803200.zip`
* **type backup:**
  string

## Components

#### HINT
Use [`POST /api/projects/(string:project)/components/`](#post--api-projects-(string-project)-components-) to create new components.

### GET /api/components/

Returns a list of translation components.

#### SEE ALSO
Component object attributes are documented at [`GET /api/components/(string:project)/(string:component)/`](#get--api-components-(string-project)-(string-component)-).

### GET /api/components/(*string:* project)/(*string:* component)/

Returns information about the translation component.

* **Parameters:**
  * **project** (*string*) – Project URL slug
  * **component** (*string*) – Component URL slug
* **Response JSON Object:**
  * **project** (*object*) – the translation project; see [`GET /api/projects/(string:project)/`](#get--api-projects-(string-project)-)
  * **name** (*string*) – [Component name](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#component-name)
  * **slug** (*string*) – [Component slug](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#component-slug)
  * **vcs** (*string*) – [Version control system](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#component-vcs)
  * **vcs_params** (*object*) – [Version control parameters](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#component-vcs-params)
  * **linked_component** (*string*) – component whose repository is linked via [Weblate internal URLs](https://docs.weblate.org/en/weblate-2026.10/vcs.md#internal-urls)
  * **repo** (*string*) – [Source code repository](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#component-repo), this is the actual repository URL even when [Weblate internal URLs](https://docs.weblate.org/en/weblate-2026.10/vcs.md#internal-urls) are used, use `linked_component` to detect this situation
  * **git_export** (*string*) – [Exported repository URL](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#component-git-export)
  * **branch** (*string*) – [Repository branch](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#component-branch), this is the actual repository branch even when [Weblate internal URLs](https://docs.weblate.org/en/weblate-2026.10/vcs.md#internal-urls) are used
  * **push** (*string*) – [Repository push URL](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#component-push), this is the actual repository URL even when [Weblate internal URLs](https://docs.weblate.org/en/weblate-2026.10/vcs.md#internal-urls) are used
  * **push_branch** (*string*) – [Push branch](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#component-push-branch), this is the actual repository branch even when [Weblate internal URLs](https://docs.weblate.org/en/weblate-2026.10/vcs.md#internal-urls) are used
  * **filemask** (*string*) – [File mask](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#component-filemask)
  * **template** (*string*) – [Monolingual base language file](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#component-template)
  * **edit_template** (*string*) – [Edit base file](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#component-edit-template)
  * **intermediate** (*string*) – [Intermediate language file](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#component-intermediate)
  * **new_base** (*string*) – [Template for new translations](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#component-new-base)
  * **file_format** (*string*) – [File format](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#component-file-format)
  * **file_format_params** (*object*) – [File format parameters](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#component-file-format-params)
  * **license** (*string*) – [Translation license](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#component-license)
  * **agreement** (*string*) – [Contributor license agreement](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#component-agreement)
  * **new_lang** (*string*) – [Adding new translation](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#component-new-lang)
  * **language_code_style** (*string*) – [Language code style](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#component-language-code-style)
  * **source_language** (*object*) – source language object; see [`GET /api/languages/(string:language)/`](#get--api-languages-(string-language)-)
  * **check_flags** (*string*) – [Translation flags](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#component-check-flags)
  * **priority** (*string*) – [Priority](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#component-priority)
  * **enforced_checks** (*array*) – Locally configured [enforced checks](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#component-enforced-checks).
  * **inherit_enforced_checks** (*boolean*) – Whether enforced checks are inherited from the category, project, or workspace.
  * **effective_enforced_checks** (*array*) – Enforced checks currently applied to the component (read-only).
  * **restricted** (*string*) – [Restricted access](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#component-restricted)
  * **repoweb** (*string*) – [Repository browser](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#component-repoweb)
  * **repoweb_translations** (*string*) – [Repository browser for translations](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#component-repoweb-translations)
  * **report_source_bugs** (*string*) – [Source string bug reporting address](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#component-report-source-bugs)
  * **merge_style** (*string*) – [Merge style](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#component-merge-style)
  * **commit_message** (*string*) – [Commit, add, delete, merge, add-on, and merge request messages](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#component-commit-message)
  * **add_message** (*string*) – [Commit, add, delete, merge, add-on, and merge request messages](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#component-add-message)
  * **delete_message** (*string*) – [Commit, add, delete, merge, add-on, and merge request messages](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#component-delete-message)
  * **merge_message** (*string*) – [Commit, add, delete, merge, add-on, and merge request messages](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#component-merge-message)
  * **addon_message** (*string*) – [Commit, add, delete, merge, add-on, and merge request messages](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#component-addon-message)
  * **pull_message** (*string*) – [Commit, add, delete, merge, add-on, and merge request messages](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#component-pull-message)
  * **allow_translation_propagation** (*string*) – [Allow translation propagation](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#component-allow-translation-propagation)
  * **hide_glossary_matches** (*boolean*) – [Do not show glossary matches](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#component-hide-glossary-matches)
  * **contribute_project_tm** (*boolean*) – [Contribute to project translation memory](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#component-contribute-project-tm)
  * **enable_suggestions** (*string*) – [Enable suggestions](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#component-enable-suggestions)
  * **suggestion_voting** (*string*) – [Suggestion voting](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#component-suggestion-voting)
  * **suggestion_autoaccept** (*string*) – [Automatically accept suggestions](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#component-suggestion-autoaccept)
  * **push_on_commit** (*boolean*) – [Push on commit](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#component-push-on-commit); linked repositories expose the effective value from the linked component
  * **locked** (*bool*) – Whether component is locked, this field is read-only; see [`GET /api/components/(string:project)/(string:component)/lock/`](#get--api-components-(string-project)-(string-component)-lock-)
  * **commit_pending_age** (*integer*) – [Age of changes to commit](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#component-commit-pending-age); linked repositories expose the effective value from the linked component
  * **auto_lock_error** (*boolean*) – [Lock on error](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#component-auto-lock-error); linked repositories expose the effective value from the linked component
  * **language_regex** (*string*) – [Language filter](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#component-language-regex)
  * **variant_regex** (*string*) – [Variants regular expression](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#component-variant-regex)
  * **is_glossary** (*bool*) – [Use as a glossary](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#component-is-glossary)
  * **glossary_color** (*string*) – [Glossary color](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#component-glossary-color)
  * **repository_url** (*string*) – URL to repository status; see [`GET /api/components/(string:project)/(string:component)/repository/`](#get--api-components-(string-project)-(string-component)-repository-)
  * **translations_url** (*string*) – URL to translations list; see [`GET /api/components/(string:project)/(string:component)/translations/`](#get--api-components-(string-project)-(string-component)-translations-)
  * **lock_url** (*string*) – URL to lock status; see [`GET /api/components/(string:project)/(string:component)/lock/`](#get--api-components-(string-project)-(string-component)-lock-)
  * **changes_list_url** (*string*) – URL to changes list; see [`GET /api/components/(string:project)/(string:component)/changes/`](#get--api-components-(string-project)-(string-component)-changes-)
  * **task_url** (*string*) – URL to a background task (if any); see [`GET /api/tasks/(str:uuid)/`](#get--api-tasks-(str-uuid)-)
  * **reports_url** (*string*) – URL to list or generate scoped reports; see [`GET /api/components/(string:project)/(string:component)/reports/`](#get--api-components-(string-project)-(string-component)-reports-)
  * **announcements_url** (*string*) – URL to announcements; see [`GET /api/components/(string:project)/(string:component)/announcements/`](#get--api-components-(string-project)-(string-component)-announcements-)

Repository fields, including `linked_component`, are returned only with
the View upstream repository location permission.

**Example JSON data:**

```json
{
    "branch": "main",
    "file_format": "po",
    "file_format_params": {
        "po_line_wrap": 65535,
        "po_no_location": true
    },
    "filemask": "po/*.po",
    "git_export": "",
    "license": "",
    "license_url": "",
    "name": "Weblate",
    "slug": "weblate",
    "project": {
        "name": "Hello",
        "slug": "hello",
        "source_language": {
            "code": "en",
            "direction": "ltr",
             "population": 159034349015,
            "name": "English",
            "url": "http://example.com/api/languages/en/",
            "web_url": "http://example.com/languages/en/"
        },
        "url": "http://example.com/api/projects/hello/",
        "web": "https://weblate.org/",
        "web_url": "http://example.com/projects/hello/"
    },
    "source_language": {
        "code": "en",
        "direction": "ltr",
        "population": 159034349015,
        "name": "English",
        "url": "http://example.com/api/languages/en/",
        "web_url": "http://example.com/languages/en/"
    },
    "repo": "file:///home/nijel/work/weblate-hello",
    "template": "",
    "new_base": "",
    "url": "http://example.com/api/components/hello/weblate/",
    "vcs": "git",
    "web_url": "http://example.com/projects/hello/weblate/"
}
```

### PATCH /api/components/(*string:* project)/(*string:* component)/

Edit a component by a [PATCH](https://www.rfc-editor.org/rfc/rfc5789#section-2) request.

* **Parameters:**
  * **project** (*string*) – Project URL slug
  * **component** (*string*) – Component URL slug
  * **source_language** (*string*) – Project source language code (optional)
* **Request JSON Object:**
  * **name** (*string*) – name of component
  * **slug** (*string*) – slug of component
  * **repo** (*string*) – VCS repository URL
  * **hide_glossary_matches** (*boolean*) – [Do not show glossary matches](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#component-hide-glossary-matches)
  * **contribute_project_tm** (*boolean*) – [Contribute to project translation memory](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#component-contribute-project-tm)

Linking to another Weblate component using an [internal URL](https://docs.weblate.org/en/weblate-2026.10/vcs.md#internal-urls) requires permission to edit the referenced component.
Changing [Restricted access](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#component-restricted) follows the same direct
component-access restrictions as the web interface.

**CURL example:**

```sh
curl \
    --data-binary '{"name": "new name"}' \
    -H "Content-Type: application/json" \
    -H "Authorization: Token TOKEN" \
    PATCH http://example.com/api/projects/hello/components/
```

**JSON request example:**

```http
PATCH /api/projects/hello/components/ HTTP/1.1
Host: example.com
Accept: application/json
Content-Type: application/json
Authorization: Token TOKEN
Content-Length: 20

{
    "name": "new name"
}
```

**JSON response example:**

```http
HTTP/1.0 200 OK
Date: Tue, 12 Apr 2016 09:32:50 GMT
Server: WSGIServer/0.1 Python/2.7.11+
Vary: Accept, Accept-Language, Cookie
X-Frame-Options: SAMEORIGIN
Content-Type: application/json
Content-Language: en
Allow: GET, POST, HEAD, OPTIONS

{
    "branch": "main",
    "file_format": "po",
    "file_format_params": {
        "po_line_wrap": 65535,
        "po_no_location": true
    },
    "filemask": "po/*.po",
    "git_export": "",
    "license": "",
    "license_url": "",
    "name": "new name",
    "slug": "weblate",
    "project": {
        "name": "Hello",
        "slug": "hello",
        "source_language": {
            "code": "en",
            "direction": "ltr",
            "population": 159034349015,
            "name": "English",
            "url": "http://example.com/api/languages/en/",
            "web_url": "http://example.com/languages/en/"
        },
        "url": "http://example.com/api/projects/hello/",
        "web": "https://weblate.org/",
        "web_url": "http://example.com/projects/hello/"
    },
    "repo": "file:///home/nijel/work/weblate-hello",
    "template": "",
    "new_base": "",
    "url": "http://example.com/api/components/hello/weblate/",
    "vcs": "git",
    "web_url": "http://example.com/projects/hello/weblate/"
}
```

### PUT /api/components/(*string:* project)/(*string:* component)/

Edit a component by a [PUT](https://www.rfc-editor.org/rfc/rfc7231#section-4.3.4) request.

* **Parameters:**
  * **project** (*string*) – Project URL slug
  * **component** (*string*) – Component URL slug
* **Request JSON Object:**
  * **branch** (*string*) – VCS repository branch
  * **file_format** (*string*) – file format of translations
  * **file_format_params** (*object*) – parameters related to the file
  * **filemask** (*string*) – mask of translation files in the repository
  * **name** (*string*) – name of component
  * **slug** (*string*) – slug of component
  * **repo** (*string*) – VCS repository URL
  * **template** (*string*) – base file for monolingual translations
  * **new_base** (*string*) – base file for adding new translations
  * **vcs** (*string*) – version control system
  * **vcs_params** (*object*) – [Version control parameters](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#component-vcs-params)
  * **hide_glossary_matches** (*boolean*) – [Do not show glossary matches](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#component-hide-glossary-matches)
  * **contribute_project_tm** (*boolean*) – [Contribute to project translation memory](https://docs.weblate.org/en/weblate-2026.10/admin/projects.md#component-contribute-project-tm)

### DELETE /api/components/(*string:* project)/(*string:* component)/

Deletes a component.

* **Parameters:**
  * **project** (*string*) – Project URL slug
  * **component** (*string*) – Component URL slug

### GET /api/components/(*string:* project)/(*string:* component)/changes/

Returns a list of component changes. This is essentially a component scoped
[`GET /api/changes/`](#get--api-changes-) accepting same params.

* **Parameters:**
  * **project** (*string*) – Project URL slug
  * **component** (*string*) – Component URL slug
* **Response JSON Object:**
  * **results** (*array*) – array of component objects; see [`GET /api/changes/(int:id)/`](#get--api-changes-(int-id)-)

### GET /api/components/(*string:* project)/(*string:* component)/file/

#### Versionadded
Added in version 4.9.

Downloads all available translations associated with the component as an archive file using the requested format.

* **Parameters:**
  * **project** (*string*) – Project URL slug
  * **component** (*string*) – Component URL slug
* **Query Parameters:**
  * **format** (*string*) – The archive format to use; If not specified, defaults to `zip`; Supported formats: `zip` and `zip:CONVERSION` where `CONVERSION` is one of converters listed at [Downloading translations](https://docs.weblate.org/en/weblate-2026.10/user/files.md#download).

### GET /api/components/(*string:* project)/(*string:* component)/screenshots/

Returns a list of component screenshots.

* **Parameters:**
  * **project** (*string*) – Project URL slug
  * **component** (*string*) – Component URL slug
* **Response JSON Object:**
  * **results** (*array*) – array of component screenshots; see [`GET /api/screenshots/(int:id)/`](#get--api-screenshots-(int-id)-)

### GET /api/components/(*string:* project)/(*string:* component)/lock/

Returns component lock status.

* **Parameters:**
  * **project** (*string*) – Project URL slug
  * **component** (*string*) – Component URL slug
* **Response JSON Object:**
  * **locked** (*boolean*) – whether component is locked for updates

**Example JSON data:**

```json
{
    "locked": false
}
```

### POST /api/components/(*string:* project)/(*string:* component)/lock/

Sets component lock status.

Response is same as [`GET /api/components/(string:project)/(string:component)/lock/`](#get--api-components-(string-project)-(string-component)-lock-).

* **Parameters:**
  * **project** (*string*) – Project URL slug
  * **component** (*string*) – Component URL slug
* **Request JSON Object:**
  * **lock** – Boolean whether to lock or not.

**CURL example:**

```sh
curl \
    -d lock=true \
    -H "Authorization: Token TOKEN" \
    http://example.com/api/components/hello/weblate/repository/
```

**JSON request example:**

```http
POST /api/components/hello/weblate/repository/ HTTP/1.1
Host: example.com
Accept: application/json
Content-Type: application/json
Authorization: Token TOKEN
Content-Length: 20

{"lock": true}
```

**JSON response example:**

```http
HTTP/1.0 200 OK
Date: Tue, 12 Apr 2016 09:32:50 GMT
Server: WSGIServer/0.1 Python/2.7.11+
Vary: Accept, Accept-Language, Cookie
X-Frame-Options: SAMEORIGIN
Content-Type: application/json
Content-Language: en
Allow: GET, POST, HEAD, OPTIONS

{"locked":true}
```

### GET /api/components/(*string:* project)/(*string:* component)/repository/

Returns information about the VCS repository status.

The response is same as for [`GET /api/projects/(string:project)/repository/`](#get--api-projects-(string-project)-repository-).

Repository status requires component-wide permission on the component that
owns the repository, including when accessing it through a linked component
in another project.

* **Parameters:**
  * **project** (*string*) – Project URL slug
  * **component** (*string*) – Component URL slug
* **Response JSON Object:**
  * **needs_commit** (*boolean*) – whether there are any pending changes to commit
  * **needs_merge** (*boolean*) – whether there are any upstream changes to merge
  * **needs_push** (*boolean*) – whether there are any local changes to push
  * **remote_commit** (*string*) – Remote commit information
  * **status** (*string*) – VCS repository status as reported by VCS
  * **merge_failure** – Text describing merge failure or null if there is none

### POST /api/components/(*string:* project)/(*string:* component)/repository/

Performs the given operation on a VCS repository.

See [`POST /api/projects/(string:project)/repository/`](#post--api-projects-(string-project)-repository-) for documentation.

Repository operations require component-wide permission on the component
that owns the repository, including when accessing it through a linked
component in another project.

* **Parameters:**
  * **project** (*string*) – Project URL slug
  * **component** (*string*) – Component URL slug
* **Request JSON Object:**
  * **operation** (*string*) – Operation to perform: one of `push`, `pull`, `commit`, `reset`, `cleanup`
* **Response JSON Object:**
  * **result** (*boolean*) – result of the operation

**CURL example:**

```sh
curl \
    -d operation=pull \
    -H "Authorization: Token TOKEN" \
    http://example.com/api/components/hello/weblate/repository/
```

**JSON request example:**

```http
POST /api/components/hello/weblate/repository/ HTTP/1.1
Host: example.com
Accept: application/json
Content-Type: application/json
Authorization: Token TOKEN
Content-Length: 20

{"operation":"pull"}
```

**JSON response example:**

```http
HTTP/1.0 200 OK
Date: Tue, 12 Apr 2016 09:32:50 GMT
Server: WSGIServer/0.1 Python/2.7.11+
Vary: Accept, Accept-Language, Cookie
X-Frame-Options: SAMEORIGIN
Content-Type: application/json
Content-Language: en
Allow: GET, POST, HEAD, OPTIONS

{"result":true}
```

### GET /api/components/(*string:* project)/(*string:* component)/monolingual_base/

Downloads base file for monolingual translations.

* **Parameters:**
  * **project** (*string*) – Project URL slug
  * **component** (*string*) – Component URL slug

### GET /api/components/(*string:* project)/(*string:* component)/new_template/

Downloads template file for new translations.

* **Parameters:**
  * **project** (*string*) – Project URL slug
  * **component** (*string*) – Component URL slug

### GET /api/components/(*string:* project)/(*string:* component)/translations/

Returns a list of translation objects in the given component.

* **Parameters:**
  * **project** (*string*) – Project URL slug
  * **component** (*string*) – Component URL slug
* **Response JSON Object:**
  * **results** (*array*) – array of translation objects; see [`GET /api/translations/(string:project)/(string:component)/(string:language)/`](#get--api-translations-(string-project)-(string-component)-(string-language)-)

### POST /api/components/(*string:* project)/(*string:* component)/translations/

Creates new translation in the given component.

* **Parameters:**
  * **project** (*string*) – Project URL slug
  * **component** (*string*) – Component URL slug
* **Request JSON Object:**
  * **language_code** (*string*) – translation language code; see [`GET /api/languages/(string:language)/`](#get--api-languages-(string-language)-)
  * **from_component** (*array*) – optional ordered list of source component references used for automatic translation. Accepts numeric component IDs or full Weblate component paths. For form submissions this field can be provided multiple times.
* **Response JSON Object:**
  * **result** (*object*) – new translation object created

**CURL example:**

```sh
curl \
    -d language_code=cs \
    -H "Authorization: Token TOKEN" \
    http://example.com/api/projects/hello/components/
```

**JSON request example:**

```http
POST /api/projects/hello/components/ HTTP/1.1
Host: example.com
Accept: application/json
Content-Type: application/json
Authorization: Token TOKEN
Content-Length: 20

{
    "language_code": "cs",
    "from_component": ["hello/weblate", 123]
}
```

**JSON response example:**

```http
HTTP/1.0 200 OK
Date: Tue, 12 Apr 2016 09:32:50 GMT
Server: WSGIServer/0.1 Python/2.7.11+
Vary: Accept, Accept-Language, Cookie
X-Frame-Options: SAMEORIGIN
Content-Type: application/json
Content-Language: en
Allow: GET, POST, HEAD, OPTIONS

{
    "failing_checks": 0,
    "failing_checks_percent": 0,
    "failing_checks_words": 0,
    "filename": "po/cs.po",
    "fuzzy": 0,
    "fuzzy_percent": 0.0,
    "fuzzy_words": 0,
    "have_comment": 0,
    "have_suggestion": 0,
    "is_template": false,
    "is_source": false,
    "language": {
        "code": "cs",
        "direction": "ltr",
        "population": 1303174280
        "name": "Czech",
        "url": "http://example.com/api/languages/cs/",
        "web_url": "http://example.com/languages/cs/"
    },
    "language_code": "cs",
    "id": 125,
    "last_author": null,
    "last_change": null,
    "share_url": "http://example.com/engage/hello/cs/",
    "total": 4,
    "total_words": 15,
    "translate_url": "http://example.com/translate/hello/weblate/cs/",
    "translated": 0,
    "translated_percent": 0.0,
    "translated_words": 0,
    "url": "http://example.com/api/translations/hello/weblate/cs/",
    "web_url": "http://example.com/projects/hello/weblate/cs/"
}
```

### GET /api/components/(*string:* project)/(*string:* component)/statistics/

Returns paginated statistics for all translations within component.

* **Parameters:**
  * **project** (*string*) – Project URL slug
  * **component** (*string*) – Component URL slug

#### SEE ALSO
Returned attributes are described in [Statistics](#api-statistics).

### GET /api/components/(*string:* project)/(*string:* component)/links/

Returns projects linked with a component.

Component managers see every linked project. Other callers see only linked
projects they can access.

#### Versionadded
Added in version 4.5.

* **Parameters:**
  * **project** (*string*) – Project URL slug
  * **component** (*string*) – Component URL slug
* **Response JSON Object:**
  * **projects** (*array*) – associated projects; see [`GET /api/projects/(string:project)/`](#get--api-projects-(string-project)-)

### POST /api/components/(*string:* project)/(*string:* component)/links/

Associate project with a component.

This requires permission to edit the component and the target project.

#### Versionadded
Added in version 4.5.

#### Versionchanged
Changed in version 5.17.

* **Parameters:**
  * **project** (*string*) – Project URL slug
  * **component** (*string*) – Component URL slug
* **Form Parameters:**
  * **string project_slug** – Project slug
  * **int category_id** – Category ID in the target project (optional).
    The category must belong to the specified project.

### DELETE /api/components/(*string:* project)/(*string:* component)/links/(*string:* project_slug)/

Remove association of a project with a component.

#### Versionadded
Added in version 4.5.

* **Parameters:**
  * **project** (*string*) – Project URL slug
  * **component** (*string*) – Component URL slug
  * **project_slug** (*string*) – Slug of the project to remove

### GET /api/components/(*string:* project)/(*string:* component)/reports/

Lists accessible reports generated directly for a component.

### POST /api/components/(*string:* project)/(*string:* component)/reports/

Schedules a report using the component as its scope. The request and response
match [`POST /api/reports/`](#post--api-reports-); scope fields must be omitted.

### GET /api/components/(*string:* project)/(*string:* component)/announcements/

#### Versionadded
Added in version 5.17: Returns announcements for a component.

* **param project:**
  Project URL slug
* **type project:**
  string
* **param component:**
  Component URL slug
* **type component:**
  string
* **>json int id:**
  ID of the announcement
* **>json string message:**
  announcement text
* **>json string severity:**
  color of the message, one of `info` (light blue), `warning` (yellow), `danger` (red), `success` (green)
* **>json date expiry:**
[...]
